precision highp float;
#define fragColor gl_FragColor
varying  vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform  float strength;
uniform  float warp;

//highp vec3 rgb2hsv(highp vec3 c)
//{
//    highp vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
//    highp vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
//    highp vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));
//
//    highp float d = q.x - min(q.w, q.y);
//    highp float e = 1.0e-10;
//    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
//}

vec2 random2(vec3 c) {
    float j = 4096.0*sin(dot(c, vec3(17.0, 59.4, 15.0)));
    vec2 r;
    r.y = fract(512.0*j);
    j *= .125;
    r.x = fract(512.0*j);
    j *= .125;
    return r - 0.5;
}

vec3 random3(vec3 c) {
    float j = 4096.0*sin(dot(c, vec3(17.0, 59.4, 15.0)));
    vec3 r;
    r.z = fract(512.0*j);
    j *= .125;
    r.x = fract(512.0*j);
    j *= .125;
    r.y = fract(512.0*j);
    return r - 0.5;
}

float random(vec3 c) {
    return sin(dot(c, vec3(17.0, 59.4, 15.0)) * 4096.0);
}

const float F3 =  0.3333333;
const float G3 =  0.1666667;


float snoise(vec3 p) {

    vec3 s = floor(p + dot(p, vec3(F3)));
    vec3 x = p - s + dot(s, vec3(G3));

    vec3 e = step(vec3(0.0), x - x.yzx);
    vec3 i1 = e*(1.0 - e.zxy);
    vec3 i2 = 1.0 - e.zxy*(1.0 - e);

    vec3 x1 = x - i1 + G3;
    vec3 x2 = x - i2 + 2.0*G3;
    vec3 x3 = x - 1.0 + 3.0*G3;

    vec4 w, d;

    w.x = dot(x, x);
    w.y = dot(x1, x1);
    w.z = dot(x2, x2);
    w.w = dot(x3, x3);

    w = max(0.6 - w, 0.0);

    d.x = dot(random3(s), x);
    d.y = dot(random3(s + i1), x1);
    d.z = dot(random3(s + i2), x2);
    d.w = dot(random3(s + 1.0), x3);

    w *= w;
    w *= w;
    d *= w;

    return dot(d, vec4(52.0));
}

void main() {
    vec2 uv = textureCoordinate;
    vec4 tempPixel = texture2D(inputImageTexture2, uv);
    vec4 srcPixel = texture2D(inputImageTexture, uv);
    float lumSrc = (srcPixel.r + srcPixel.g + srcPixel.b) / 3.;
    float lum = tempPixel.b;
//    vec3 col = texture2D(inputImageTexture, uv + strength * lum * vec2(snoise(vec3(lum, abs(uv.x - 0.5), abs(uv.y - 0.5)))) / (1.)).rgb;
    float scale = (1. - pow(abs(lum * 10.), 0.8));
    uv += lum * scale * uv/ (1. + warp);
    vec3 col = texture2D(inputImageTexture, uv).rgb;
    col += col * scale / (1. + warp);
    gl_FragColor = vec4(col, 1.0);

}